module Easy
  module Configuration
    module Auth

      cattr_accessor :required
      self.required = false

      cattr_accessor :no_password_auth
      self.no_password_auth = false

      cattr_accessor :only_omniauth
      self.only_omniauth = false

      cattr_accessor :allow_anonymous_readonly_api
      self.allow_anonymous_readonly_api = false

      cattr_accessor :token_auth
      self.token_auth = false

      class << self

        def required?
          !!self.required
        end

        def no_password_auth?
          !!self.no_password_auth
        end

        def token_auth?
          !!self.token_auth
        end

        def allow_anonymous_readonly_api?
          !!self.allow_anonymous_readonly_api
        end

        def only_omniauth?
          !!self.only_omniauth
        end

        def omniauth_providers
          Rails.application.secrets.omniauth_providers || {}
        end

        def omniauth_providers_keys
          omniauth_providers.keys
        end

        def social_sign_in?
          (%i(facebook google_oauth2 twitter linkedin) & omniauth_providers_keys).present?
        end

      end

    end
  end
end
