module Easy
  module Configuration
    class Custom

      def method_missing(name, *args)
        name_string = name.to_s
        if name_string.chomp!("=")
          from_file[name_string] = args.first
        else
          bangs = name_string.chomp!("!")

          if bangs
            from_file[name_string].presence || raise(KeyError.new(":#{name_string} is blank"))
          else
            from_file[name_string]
          end
        end
      end

      def respond_to_missing?(name, include_private)
        true
      end

      private

      def from_file
        @from_file ||= begin
          file_path = Rails.root.join('config/config.yml')
          File.exists?(file_path) ? YAML.load_file(file_path) : {}
        end
      end

    end
  end
end
