module Easy
  module Configuration
    class Entity

      attr_accessor :no_count

      def initialize(klass_name)
        @klass_name   = klass_name
        @no_count     = false
        @menu         = Hash.new { |hash, key| hash[key.to_s] = Menu.new }
      end

      def no_count?
        !!no_count
      end

      def menu(section, &block)
        if block_given?
          yield @menu[section.to_s]
        else
          @menu[section.to_s]
        end
      end

    end
  end
end
