module Easy
  module Configuration
    class MenuCustomLink < MenuTitle

      attr_reader :icon

      def initialize(options = {}, &block)
        @url          = options.delete(:url)
        @title        = options.delete(:title)
        @icon         = options.delete(:icon)

        super(options, &block)
      end

      def title
        case @title
        when String
          @title
        else
          I18n.t(@title)
        end
      end

      def url(view_context, decorator)
        case @url
        when Proc
          @url.call(view_context, decorator)
        end
      end

    end
  end
end
