module Easy
  module Configuration
    class MenuItem

      attr_reader :children, :link_setup, :html_options

      def initialize(options = {}, &block)
        @visibility   = options.delete(:visibility)
        @html_options = options.delete(:html) || {}
        @options      = options
        @link_setup   = block
        @children     = {}
      end

      def children?
        @children.present?
      end

      def visible?(current_user)
        case @visibility
        when Proc
          @visibility.call(current_user)
        when NilClass
          true
        else
          !!@visibility
        end
      end

    end
  end
end
